#ifndef EMSubataWrapper_WRAPPER_HEADER_H
#define EMSubataWrapper_WRAPPER_HEADER_H

#include "sub/SubDataWrapper.h"
#include "can_msg_node/executable.h"
#include <mviz/mviz.h>
#include <publisher.h>
#include "can/SignalsToSWCs_Type.h"
#include <cstdlib>

template <typename DataType>
class VIZ_SubDataWrapper :  public SubDataWrapper<DataType>
{
	mviz::Publisher *_pub;
	void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {

		can::SignalsToSWCs_Type data;

		std::cout << sizeof(can::SignalsToSWCs_Type) << "  -  " << sizeof(DataType) << std::endl;

		std::memcpy(&data, ptr->Get(), sizeof(can::SignalsToSWCs_Type));

		_pub->Publish(data);
	
    }
public:
	void set_publisher(mviz::Publisher *pub)
	{
		_pub = pub;
	}

};

//
///*-------------------------------------------------------------------------------------------------------------------------*/
//template <typename DataType>
//class SLAM2EMattribute_SubDataWrapper :  public SubDataWrapper<DataType>
//
//
//{
//	void Process(ara::com::SamplePtr<DataType const>* ptr) override
//    {
//	    auto sample = ptr->Get();
//    }
//};
//
//
///*-------------------------------------------------------------------------------------------------------------------------*/
//template <typename DataType>
//class SLAM2EMline_point_SubDataWrapper :  public SubDataWrapper<DataType>
//
//
//{
//	void Process(ara::com::SamplePtr<DataType const>* ptr) override
//    {
//	    auto sample = ptr->Get();
//    }
//};
//
//
///*-------------------------------------------------------------------------------------------------------------------------*/
//template <typename DataType>
//class SLAM2EMline_SubDataWrapper :  public SubDataWrapper<DataType>
//
//
//{
//	void Process(ara::com::SamplePtr<DataType const>* ptr) override
//    {
//	    auto sample = ptr->Get();
//    }
//};
//
//
///*-------------------------------------------------------------------------------------------------------------------------*/
//template <typename DataType>
//class SLAM2EMspeed_limit_SubDataWrapper :  public SubDataWrapper<DataType>
//
//
//{
//	void Process(ara::com::SamplePtr<DataType const>* ptr) override
//    {
//	    auto sample = ptr->Get();
//    }
//};
//
//
///*-------------------------------------------------------------------------------------------------------------------------*/
//template <typename DataType>
//class SLAM2EMtraffic_object_SubDataWrapper :  public SubDataWrapper<DataType>
//
//
//{
//	void Process(ara::com::SamplePtr<DataType const>* ptr) override
//    {
//	    auto sample = ptr->Get();
//    }
//};
//
//
///*-------------------------------------------------------------------------------------------------------------------------*/
//template <typename DataType>
//class SLAM2EMlane_SubDataWrapper :  public SubDataWrapper<DataType>
//
//
//{
//	void Process(ara::com::SamplePtr<DataType const>* ptr) override
//    {
//	    auto sample = ptr->Get();
//    }
//};
//
//
///*-------------------------------------------------------------------------------------------------------------------------*/
//template <typename DataType>
//class SLAM2EMroad_edge_SubDataWrapper :  public SubDataWrapper<DataType>
//
//
//{
//	void Process(ara::com::SamplePtr<DataType const>* ptr) override
//    {
//	    auto sample = ptr->Get();
//    }
//};
//
//
///*-------------------------------------------------------------------------------------------------------------------------*/
//template <typename DataType>
//class SLAM2EMslam_road_model_SubDataWrapper :  public SubDataWrapper<DataType>
//
//
//{
//	void Process(ara::com::SamplePtr<DataType const>* ptr) override
//    {
//	    auto sample = ptr->Get();
//    }
//};
//
//
///*-------------------------------------------------------------------------------------------------------------------------*/
//template <typename DataType>
//class FusionObjects_SubDataWrapper :  public SubDataWrapper<DataType>
//
//
//{
//	void Process(ara::com::SamplePtr<DataType const>* ptr) override
//    {
//	    auto sample = ptr->Get();
//    }
//};
//
#endif
